import {
  select,
	json,
  csv,
  geoPath,
  geoAlbersUsa,
  scaleThreshold,
  scaleOrdinal,
  schemeOrRd,
  filter
} from 'd3';

import {
feature
} from 'topojson';

const svg = select('svg');

const projection = geoAlbersUsa();
const pathGenerator = geoPath().projection(projection);

const g = svg.append('g');

Promise.all([
	csv('https://vizhub.com/elaine-xiao/datasets/state-earthquakes.csv'),
  json('https://vizhub.com/elaine-xiao/datasets/states-10m.json')
]).then(([csvData, topoJASONdata]) => {
  
  const regionname = {};
  const earthquakesnum = {};
  const earthquakesnumlog = {};
  const colorsample = {};
  
  csvData.forEach(d => {
    
    regionname[d.States] = d.Region;
    earthquakesnum[d.States] = d["Total Earthquakes"];
    d["Total Earthquakes"] = Math.log((+d["Total Earthquakes"])+1);
    earthquakesnumlog[d.States] = d["Total Earthquakes"];
  
  });
  
  
  
  const states = feature(topoJASONdata, topoJASONdata.objects.states);
  const colorScale = scaleOrdinal();
  //const colorScale = scaleThreshold();
  
  const colorValue = d => earthquakesnumlog[d.properties.name];

  
  
  colorScale.domain(states.features.map(colorValue))
  	//.domain([0,1,2,3,4,5,6,7,8])
    
  colorScale.domain(colorScale.domain().filter(function (el) {
  return el != null;}).sort())
  	.range(schemeOrRd[9]);
  
  console.log(colorScale.range());
  console.log(colorScale.domain());
  
  
  g.selectAll('path')
  	.data(states.features)
    .enter()
    	.append('path')
  			.attr('class', 'state')
  			.attr('d', pathGenerator)
  			.attr('fill', d => colorScale(colorValue(d)))
  		.append('title')
  			.text("State: ")
  		.append('title1')
  			.text(d => d.properties.name)
    	.append('title2')
  			.text("\nRegion: ")
  		.append('title3')
  			.text(d => regionname[d.properties.name])
     	.append('title4')
  			.text("\nEarthquakes: ")
  		.append('title5')
  			//.text(d => earthquakesnumlog[d.properties.name]) ; 
  			.text(d => earthquakesnum[d.properties.name]) ; 

  
});